# Declarative Routing for React

React components are the heart of React's powerful programming model.
Their declarative nature makes them incredibly composable. React Router
is a declarative way to render, at any location, any UI that you and your
team can think up. You should be able to solve these use-cases elegantly
with component composition.

React Router desires to have no public interface outside of components
and props. At any time, you should be able to look at the render method
of a component and understand what it’s doing.  If you need to redirect,
block transitions, or match a location, you should be able to do so
declaratively.

## Just Getting Started?

1. First read the [Quick Start](quick-start)
2. Browse the examples on this site
3. Read the API docs on this site

## Contributing

We'd love your help, the code is [hosted on GitHub](https://github.com/reactjstraining/react-router).

## Thanks

Development has been sponsored by:

- [React Training][react-training]
- [Instructure][instructure]
- [Modus Create][modus-create]
- [100s of Contributors][contributors]


  [react-training]:https://reactjs-training.com
  [instructure]:https://instructure.com
  [modus-create]:https://modus-create.com
  [contributors]:https://github.com/reactjs/react-router/graphs/contributors
